* Google_API.prg

DemoWinHttpRequest()
* Rcuprer le jeton : via l'URL
* https://accounts.google.com/o/oauth2/auth?client_id=131577566180-eomcsqokpnj2vf40vlbbeo9j1ff8frvd.apps.googleusercontent.com&scope=https://www.googleapis.com/auth/calendar&response_type=code&redirect_uri=urn:ietf:wg:oauth:2.0:oob&access_type=offline&approval_prompt=force
* DemoGetAuthToken()
* DemoGetEventsList()
* DemoAddEvent()

*************************************************************************************************************************************** 
Function DemoWinHttpRequest
	* Dmo de WinHttp.WinHttpRequest
	Local loWinHttpReq, lcURL, lcRep
	loWinHttpReq=Createobject("WinHttp.WinHttpRequest.5.1")
	*lcURL = "http://www.atoutfox.org"
	*lcURL = "http://samples.openweathermap.org/data/2.5/forecast/daily?id=524901&appid=b1b15e88fa797225412429c1c50c122a1"
	lcURL="https://www.googleapis.com/calendar/v3/calendars/atoutfox%40limoog.net/events"
	m.loWinHttpReq.Open("GET", m.lcURL, .F.)             
	m.loWinHttpReq.Send()
	m.lcRep = m.loWinHttpReq.responseText
	MessageBox(lcRep)
	Return 
Endfunc 

*************************************************************************************************************************************** 
Function DemoGetAuthToken
	Local lo, lcCode, lcToken
	m.lo = CreateObject("cAPIWebPlanning")
	* Coller ici le code fourni par l'tape 1 de l'authentification (il commence a priori toujours par "4/")
	* https://accounts.google.com/o/oauth2/auth?client_id=131577566180-eomcsqokpnj2vf40vlbbeo9j1ff8frvd.apps.googleusercontent.com&scope=https://www.googleapis.com/auth/calendar&response_type=code&redirect_uri=urn:ietf:wg:oauth:2.0:oob&access_type=offline&approval_prompt=force
	m.lcCode = "4/UwEpXDALaBy9BH2XqKz7mvwgHq0cDcVu0yz8bDtfmEBweBfLGS0fhws"
	m.lo.getAuthToken(m.lcCode, @m.lcToken)
	_cliptext = m.lcToken
	MessageBox("Le token a t plac dans le presse-papier" + Chr(13) + m.lcToken)
	Return
Endfunc

*************************************************************************************************************************************** 
Function DemoGetEventsList
	Local lo, lcCode, lcListe
	m.lo = CreateObject("cAPIWebPlanning")
	* Coller ici le token fourni par la 2eme tape de l'athentification (getAuthToken : https://accounts.google.com/o/oauth2/auth?client_id=131577566180-eomcsqokpnj2vf40vlbbeo9j1ff8frvd.apps.googleusercontent.com&scope=https://www.googleapis.com/auth/calendar&response_type=code&redirect_uri=urn:ietf:wg:oauth:2.0:oob&access_type=offline&approval_prompt=force&login_hint=atoutfox@limoog.net)
	* (il commence a priori toujours par "ya29.")
	m.lo.cAuth_Token = "ya29.GlsSB7YW_bTuAof0WWjhWJ13YWhiLSHb4IEoEz8CQpXJTDDOz8PSZr7qszA1PR4dfSd4V4-QXH9xNv2rM_oub4LEP2ojI2O3HFwaJ8rS_QZusUH-6vqn6C3FBmYZ"
	m.lo.getEventsList(@m.lcListe)
	_cliptext = m.lcListe
	MessageBox(m.lcListe)
	Return
Endfunc

*************************************************************************************************************************************** 
Function DemoAddEvent
	Local lo, lcCode, lcRep
	m.lo = CreateObject("cAPIWebPlanning")
	* Coller ici le token fourni par la 2eme tape de l'athentification (getAuthToken)
	m.lo.cAuth_Token = "ya29.GlsSB7YW_bTuAof0WWjhWJ13YWhiLSHb4IEoEz8CQpXJTDDOz8PSZr7qszA1PR4dfSd4V4-QXH9xNv2rM_oub4LEP2ojI2O3HFwaJ8rS_QZusUH-6vqn6C3FBmYZ"
	m.lo.addEvent(@m.lcRep)
	MessageBox(m.lcRep)
	Return
Endfunc

***************************************************************************************************************************************
Define Class cAPIWebPlanning As Custom

	cAuth_ClientId = "131577566180-eomcsqokpnj2vf40vlbbeo9j1ff8frvd.apps.googleusercontent.com"
	cAuth_ClientSecret = "Z2bz3mNg2sGZ9uxd6eSZKxDy"
	cAuth_Code = ""
	cAuth_Token = ""
	
	cGoogle_UserId = "atoutfox%40limoog.net"
	
	* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
	Function getAuthToken
		Lparameters pcCode, pcToken
		Local lcURL, lcPost, lcRep
		
		m.lcURL = "http://accounts.google.com/o/oauth2/token"
		m.lcPost = "client_id=" + This.cAuth_ClientId ;
					+ "&client_secret=" + This.cAuth_ClientSecret ;
					+ "&code=" + m.pcCode ;
					+ "&redirect_uri=urn:ietf:wg:oauth:2.0:oob" ;
					+ "&grant_type=authorization_code"
		m.llKO = Not This.HTTPPost(m.lcURL, m.lcPost, @m.lcRep)
		Do case
			Case m.llKO
				* Echec de la requte vers Google
				m.pcToken = "Echec"
			
			Case ["error":]  $ m.lcRep
				* Google a refus
*!*	{
*!*	  "error": "invalid_grant",
*!*	  "error_description": "Bad Request"
*!*	}
				m.llKO = .T.
				m.pcToken = ADroiteDe(m.lcRep, ["error_description": "])
				m.pcToken = AGaucheDe(m.pcToken, ["])
				
			Otherwise 
				* Succs de la demande de code
*!*	{
*!*	  "access_token": "ya29.GlsDB2K-3ZbXukkP3HLjIUTVhz3C3Yn6nI5n8kGGB2j536cGL56DJT1XOkWvjr0xI8p8EzjUGnJqb2yAhe-pK_TMdDCWCSyyGcWFZAWwkendah9QNGLQUAg-ffow",
*!*	  "expires_in": 3600,
*!*	  "refresh_token": "1/n8C2JR2orEDzG9JJteE1KnYO6ePLXwlSB6H9XgL1lLY",
*!*	  "scope": "https://www.googleapis.com/auth/calendar",
*!*	  "token_type": "Bearer"
*!*	}				
				* Extraire le code
				m.pcToken = ADroiteDe(m.lcRep, ["access_token": "])
				m.pcToken = AGaucheDe(m.pcToken, ["])
			
		Endcase 
		This.cAuth_Token = m.pcToken
		
		Return m.llKO
	
	EndFunc

	* -----------------------------------------------------------------------------------------------------------------------------------------------------------
	Function getEventsList
		Lparameters pcListe
		Local llKO, lcURL
		
		m.lcURL = "https://www.googleapis.com/calendar/v3/calendars/" + This.cGoogle_UserId + "/events"
		m.llKO = Not This.HTTPGet(m.lcURL, @m.pcListe, .T.)
		* NB : on peut obtenir une rponse JSON 404 si on a obtenu le code via un user qui n'a pas le droit au calendrier qu'on essaie d'interroger
		
		Return Not m.llKO
	EndFunc

	* -----------------------------------------------------------------------------------------------------------------------------------------------------------
	Function addEvent
		Lparameters pcRep
		Local llKO, lcURL, lcJSONEvent
		Text To m.lcJSONEvent Pretext 1 + 2 + 4 + 8 NoShow
			{
			  "summary": "Nouveau",
			  "location": "Hotel Ibis",
			  "description": "Mon premier vnement ajout.",
			  "start": {
			    "dateTime": "2019-05-23T16:00:00+02:00",
			    "timeZone": "Europe/Paris"
			  },
			  "end": {
			    "dateTime": "2019-05-23T17:00:00+02:00",
			    "timeZone": "Europe/Paris"
			  }
			}
		Endtext
		
		m.lcURL = "https://www.googleapis.com/calendar/v3/calendars/" + This.cGoogle_UserId + "/events"
		
		* Il faut envoyer en POST, avec l'authentification Google et en spfifiant un content-type JSON
		m.llKO = Not This.HTTPPost(m.lcURL, m.lcJSONEvent, @m.pcRep, .T., .T.)
		
		Return Not m.llKO
	EndFunc

	* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
	Function HTTPGet
		Lparameters pcUrl, pcRep, pbAvecToken

		Local loErr, loWinHttpReq, llKO
		Try
			m.loWinHttpReq=Createobject("WinHttp.WinHttpRequest.5.1")
			m.loWinHttpReq.Open("GET", m.pcURL, .F.)  
			If m.pbAvecToken          
				* Il faut donner le Token  Google dans l'en-tte HTTP (https://stackoverflow.com/questions/37262642/google-calendar-api-and-http-headers)
				m.loWinHttpReq.setRequestHeader('authorization', 'Bearer ' + this.cAuth_Token)  
			Endif
			m.loWinHttpReq.Send()
            m.pcRep = m.loWinHttpReq.responseText
		Catch To m.loErr When .T.
			m.llKO = .T.
			m.pcRep = m.loErr.Message
		Endtry

		Return Not m.llKO

	EndFunc

	* ----------------------------------------------------------------------------------------------------------------------------------------------------------- 
	Function HTTPPost
		Lparameters pcUrl, pcPostData, pcRep, pbAvecToken, pbJSONEncoded

		Local loErr, loWinHttpReq, llKO
		Try
			m.loWinHttpReq=Createobject("WinHttp.WinHttpRequest.5.1")
			m.loWinHttpReq.Open("POST", m.pcURL, .F.)
			If m.pbJSONEncoded    
	            m.loWinHttpReq.setRequestHeader('Content-Type','application/json')      
	        Else
	            m.loWinHttpReq.setRequestHeader('Content-Type','application/x-www-form-urlencoded')      
	        Endif
			If m.pbAvecToken          
				* Il faut donner le Token  Google dans l'en-tte HTTP (https://stackoverflow.com/questions/37262642/google-calendar-api-and-http-headers)
				m.loWinHttpReq.setRequestHeader('authorization', 'Bearer ' + this.cAuth_Token)  
			Endif
 			m.loWinHttpReq.Send(m.pcPostData)
            m.pcRep = m.loWinHttpReq.responseText
		Catch To m.loErr When .T.
			m.llKO = .T.
			m.pcRep = m.loErr.Message
		Endtry

		Return Not m.llKO

	EndFunc
EndDefine


*************************************************************************************************************************************** 
* psChaineComplete
* psChaineCherchee
*(pbIgnoreCasse)
Function ADroiteDe
	Lparameters psChaineComplete, psChaineCherchee, pbIgnoreCasse
	
	Local lsCh

	IF IsNull(m.psChaineComplete)
		Return ""
	Endif

	* Vrification des paramtres
	IF .not. vartype(m.psChaineComplete) = "C" .or. .not. vartype(m.psChaineCherchee) = "C"
		&gsSetStepOn
		Return ""
	Endif

	Do Case
		Case m.psChaineCherchee == ""
			Return Right(m.psChaineComplete, Len(m.psChaineComplete) - 1)
		Case At(Upper(m.psChaineCherchee), Upper(m.psChaineComplete)) = 0
			Return ""
		Case m.pbIgnoreCasse
			m.lsCh = Right(m.psChaineComplete, Len(m.psChaineComplete);
					- Atc(Upper(m.psChaineCherchee), Upper(m.psChaineComplete)) - (len(m.psChaineCherchee) - 1))
		Other
			m.lsCh = Right(m.psChaineComplete, Len(m.psChaineComplete);
					- At(Upper(m.psChaineCherchee), Upper(m.psChaineComplete)) - (len(m.psChaineCherchee) - 1))
	Endcase

	RETURN m.lsCh
Endfunc 

*************************************************************************************************************************************** 
* psChaineComplete
* psChaineCherchee
Function AGaucheDe
	LPARA psChaineComplete, psChaineCherchee, pbIgnoreCasse

	* Vrification des paramtres
	IF .not. vartype(m.psChaineComplete) = "C" .or. .not. vartype(m.psChaineCherchee) = "C"
		&gsSetStepOn
		Return ""
	Endif

	Do Case
		Case m.psChaineCherchee == ""
			Return Left(m.psChaineComplete, 1)
		Case At(Upper(m.psChaineCherchee), Upper(m.psChaineComplete))=0
			RETURN m.psChaineComplete
		Case m.pbIgnoreCasse
			RETURN Left(m.psChaineComplete, Atc(Upper(m.psChaineCherchee), Upper(m.psChaineComplete))-1)
		Other
			RETURN Left(m.psChaineComplete, At(Upper(m.psChaineCherchee), Upper(m.psChaineComplete))-1)
	Endcase
	
Endfunc 
