* Outlook_COM.prg

Local loOutlook As Outlook.Application, loMAPI As Outlook.NameSpace, lbConnect, lv

MessageBox("As-tu bien pens  arrter Outlook avant ?" + Chr(13) + "Sinon tu es bon pour attendre...")

* Cette ligne se plante au bout de 30 secondes "Echec de l'excution du serveur", quand Outlook est ouvert sur le poste
m.loOutlook = CreateObject('Outlook.Application')
m.loMAPI = m.loOutlook.GetNamespace("MAPI")


Local loErr AS Exception, lsMsgErr
Try
	* Le LogOff est-il utile ?
	m.loMAPI.Logoff()
	
	* On se connecte  un PROFIL, auquel correspond au moins une adresse mail (dont une par dfaut)
	m.loMAPI.Logon("default", "mdp_NePasUtiliserCarInclusPourCompatibilitAscendante", .F., .T.)

	m.lbConnect = .T.
Catch To m.loErr When .T.
	m.lsMsgErr = m.loErr.Message
	MessageBox("Echec de la connexion : " + m.lsMsgErr)
	m.lbConnect = .F.
EndTry

If m.lbConnect
	
	* Rcuprer la liste des Appointments
	RcupreTousAppointments(m.loMAPI)
*	RcupreCertainsAppointments(m.loMAPI)
	
	* Crer un Appointment
*	CrerAppointment(m.loOutlook)

	m.loMAPI.Logoff()
Endif

m.loOutlook.Quit()

*************************************************************************************************************************************** 
Function CrerAppointment
	Lparameters poOutlook as Outlook.Application
	
	* Crer un Appointment
	Local loAppointment as Outlook.AppointmentItem
	m.loAppointment = m.poOutlook.CreateItem(1)		&& 1 = constante OlItemType.olAppointmentItem
	m.loAppointment.Start = {^2019/05/23 15:30:00}
	m.loAppointment.End = {^2019/05/23 16:30:00}
	m.loAppointment.Subject = "Mon premier vnement ajout"
	m.loAppointment.Body = "Body de mon appointment"
*	m.loAppointment.Conflicts(0)

	* Enregistrer (retour : NULL)
	m.lv = m.loAppointment.Save()
	MessageBox("Cration OK, Save renvoie ! " + Transform(m.lv))
Endfunc

*************************************************************************************************************************************** 
* Selon https://docs.microsoft.com/fr-fr/office/vba/outlook/how-to/search-and-filter/search-the-calendar-for-appointments-within-a-date-range-that-contain-a-specific
Function RcupreTousAppointments
	Lparameters poMAPI as Outlook.NameSpace
	
	Local loCalendar as Outlook.Folder, loItems as Outlook.Items, loItemsInDateRange as Outlook.Items, lsRestriction, lsLst
	m.loCalendar = m.poMAPI.GetDefaultFolder(9)	&& 9 : OlDefaultFolders.olFolderCalendar
	
	m.loItems = m.loCalendar.Items
	m.loItems.IncludeRecurrences = .T.
	m.loItems.Sort("[Start]")
	m.lsLst = ""
    For Each m.loAppointment In m.loItems
    	m.lsLst = m.lsLst + Transform(m.loAppointment.Start) + " : "  + m.loAppointment.Subject + Chr(13)
    Next
    MessageBox(m.lsLst)
Endfunc 

*************************************************************************************************************************************** 
* Selon https://docs.microsoft.com/fr-fr/office/vba/outlook/how-to/search-and-filter/search-the-calendar-for-appointments-within-a-date-range-that-contain-a-specific
Function RcupreCertainsAppointments
	Lparameters poMAPI as Outlook.NameSpace
	
	Local loCalendar as Outlook.Folder, loItems as Outlook.Items, loItemsInDateRange as Outlook.Items, lsRestriction, lsLst
	m.loCalendar = m.poMAPI.GetDefaultFolder(9)	&& 9 : OlDefaultFolders.olFolderCalendar
	
	m.loItems = m.loCalendar.Items
	m.loItems.IncludeRecurrences = .T.
	m.loItems.Sort("[Start]")

	* Filtrer par date
    m.lsRestriction = "[Start] >= '" + "2019/01/01 00:00 AM" + "' AND [End] <= '" + "2020/01/01 00:00 AM" + "'"	
 	m.loItemsInDateRange = m.loItems.Restrict(m.lsRestriction)

	m.lsLst = ""
    For Each m.loAppointment In m.loItemsInDateRange
    	m.lsLst = m.lsLst + Transform(m.loAppointment.Start) + " : "  + m.loAppointment.Subject + Chr(13)
    Next
    MessageBox(m.lsLst)
    
Endfunc 
